Index: trunk/src/VBox/Runtime/r3/posix/semrw-posix.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/posix/semrw-posix.cpp	(revision 25721)
+++ trunk/src/VBox/Runtime/r3/posix/semrw-posix.cpp	(revision 25723)
@@ -155,10 +155,10 @@
 
 
-RTDECL(int) RTSemRWDestroy(RTSEMRW RWSem)
+RTDECL(int) RTSemRWDestroy(RTSEMRW hRWSem)
 {
     /*
      * Validate input, nil handle is fine.
      */
-    struct RTSEMRWINTERNAL *pThis = RWSem;
+    struct RTSEMRWINTERNAL *pThis = hRWSem;
     if (pThis == NIL_RTSEMRW)
         return VINF_SUCCESS;
@@ -189,5 +189,5 @@
     {
         ASMAtomicWriteU32(&pThis->u32Magic, RTSEMRW_MAGIC);
-        AssertMsgFailed(("Failed to destroy read-write sem %p, rc=%d.\n", RWSem, rc));
+        AssertMsgFailed(("Failed to destroy read-write sem %p, rc=%d.\n", hRWSem, rc));
         rc = RTErrConvertFromErrno(rc);
     }
@@ -215,10 +215,10 @@
 
 
-DECL_FORCE_INLINE(int) rtSemRWRequestRead(RTSEMRW RWSem, unsigned cMillies, PCRTLOCKVALSRCPOS pSrcPos)
-{
-    /*
-     * Validate input.
-     */
-    struct RTSEMRWINTERNAL *pThis = RWSem;
+DECL_FORCE_INLINE(int) rtSemRWRequestRead(RTSEMRW hRWSem, RTMSINTERVAL cMillies, PCRTLOCKVALSRCPOS pSrcPos)
+{
+    /*
+     * Validate input.
+     */
+    struct RTSEMRWINTERNAL *pThis = hRWSem;
     AssertPtrReturn(pThis, VERR_INVALID_HANDLE);
     AssertMsgReturn(pThis->u32Magic == RTSEMRW_MAGIC,
@@ -269,5 +269,5 @@
         if (rc)
         {
-            AssertMsgFailed(("Failed read lock read-write sem %p, rc=%d.\n", RWSem, rc));
+            AssertMsgFailed(("Failed read lock read-write sem %p, rc=%d.\n", hRWSem, rc));
             return RTErrConvertFromErrno(rc);
         }
@@ -301,5 +301,5 @@
         if (rc)
         {
-            AssertMsg(rc == ETIMEDOUT, ("Failed read lock read-write sem %p, rc=%d.\n", RWSem, rc));
+            AssertMsg(rc == ETIMEDOUT, ("Failed read lock read-write sem %p, rc=%d.\n", hRWSem, rc));
             return RTErrConvertFromErrno(rc);
         }
@@ -316,48 +316,48 @@
 
 #undef RTSemRWRequestRead
-RTDECL(int) RTSemRWRequestRead(RTSEMRW RWSem, unsigned cMillies)
+RTDECL(int) RTSemRWRequestRead(RTSEMRW hRWSem, RTMSINTERVAL cMillies)
 {
 #ifndef RTSEMRW_STRICT
-    return rtSemRWRequestRead(RWSem, cMillies, NULL);
+    return rtSemRWRequestRead(hRWSem, cMillies, NULL);
 #else
     RTLOCKVALSRCPOS SrcPos = RTLOCKVALSRCPOS_INIT_NORMAL_API();
-    return rtSemRWRequestRead(RWSem, cMillies, &SrcPos);
-#endif
-}
-
-
-RTDECL(int) RTSemRWRequestReadDebug(RTSEMRW RWSem, unsigned cMillies, RTHCUINTPTR uId, RT_SRC_POS_DECL)
+    return rtSemRWRequestRead(hRWSem, cMillies, &SrcPos);
+#endif
+}
+
+
+RTDECL(int) RTSemRWRequestReadDebug(RTSEMRW hRWSem, RTMSINTERVAL cMillies, RTHCUINTPTR uId, RT_SRC_POS_DECL)
 {
     RTLOCKVALSRCPOS SrcPos = RTLOCKVALSRCPOS_INIT_DEBUG_API();
-    return rtSemRWRequestRead(RWSem, cMillies, &SrcPos);
+    return rtSemRWRequestRead(hRWSem, cMillies, &SrcPos);
 }
 
 
 #undef RTSemRWRequestReadNoResume
-RTDECL(int) RTSemRWRequestReadNoResume(RTSEMRW RWSem, unsigned cMillies)
+RTDECL(int) RTSemRWRequestReadNoResume(RTSEMRW hRWSem, RTMSINTERVAL cMillies)
 {
     /* EINTR isn't returned by the wait functions we're using. */
 #ifndef RTSEMRW_STRICT
-    return rtSemRWRequestRead(RWSem, cMillies, NULL);
+    return rtSemRWRequestRead(hRWSem, cMillies, NULL);
 #else
     RTLOCKVALSRCPOS SrcPos = RTLOCKVALSRCPOS_INIT_NORMAL_API();
-    return rtSemRWRequestRead(RWSem, cMillies, &SrcPos);
-#endif
-}
-
-
-RTDECL(int) RTSemRWRequestReadNoResumeDebug(RTSEMRW RWSem, unsigned cMillies, RTHCUINTPTR uId, RT_SRC_POS_DECL)
+    return rtSemRWRequestRead(hRWSem, cMillies, &SrcPos);
+#endif
+}
+
+
+RTDECL(int) RTSemRWRequestReadNoResumeDebug(RTSEMRW hRWSem, RTMSINTERVAL cMillies, RTHCUINTPTR uId, RT_SRC_POS_DECL)
 {
     RTLOCKVALSRCPOS SrcPos = RTLOCKVALSRCPOS_INIT_DEBUG_API();
-    return rtSemRWRequestRead(RWSem, cMillies, &SrcPos);
-}
-
-
-RTDECL(int) RTSemRWReleaseRead(RTSEMRW RWSem)
-{
-    /*
-     * Validate input.
-     */
-    struct RTSEMRWINTERNAL *pThis = RWSem;
+    return rtSemRWRequestRead(hRWSem, cMillies, &SrcPos);
+}
+
+
+RTDECL(int) RTSemRWReleaseRead(RTSEMRW hRWSem)
+{
+    /*
+     * Validate input.
+     */
+    struct RTSEMRWINTERNAL *pThis = hRWSem;
     AssertPtrReturn(pThis, VERR_INVALID_HANDLE);
     AssertMsgReturn(pThis->u32Magic == RTSEMRW_MAGIC,
@@ -403,5 +403,5 @@
     {
         ASMAtomicIncU32(&pThis->cReaders);
-        AssertMsgFailed(("Failed read unlock read-write sem %p, rc=%d.\n", RWSem, rc));
+        AssertMsgFailed(("Failed read unlock read-write sem %p, rc=%d.\n", hRWSem, rc));
         return RTErrConvertFromErrno(rc);
     }
@@ -410,10 +410,10 @@
 
 
-DECL_FORCE_INLINE(int) rtSemRWRequestWrite(RTSEMRW RWSem, unsigned cMillies, PCRTLOCKVALSRCPOS pSrcPos)
-{
-    /*
-     * Validate input.
-     */
-    struct RTSEMRWINTERNAL *pThis = RWSem;
+DECL_FORCE_INLINE(int) rtSemRWRequestWrite(RTSEMRW hRWSem, RTMSINTERVAL cMillies, PCRTLOCKVALSRCPOS pSrcPos)
+{
+    /*
+     * Validate input.
+     */
+    struct RTSEMRWINTERNAL *pThis = hRWSem;
     AssertPtrReturn(pThis, VERR_INVALID_HANDLE);
     AssertMsgReturn(pThis->u32Magic == RTSEMRW_MAGIC,
@@ -464,5 +464,5 @@
         if (rc)
         {
-            AssertMsgFailed(("Failed write lock read-write sem %p, rc=%d.\n", RWSem, rc));
+            AssertMsgFailed(("Failed write lock read-write sem %p, rc=%d.\n", hRWSem, rc));
             return RTErrConvertFromErrno(rc);
         }
@@ -495,5 +495,5 @@
         if (rc)
         {
-            AssertMsg(rc == ETIMEDOUT, ("Failed read lock read-write sem %p, rc=%d.\n", RWSem, rc));
+            AssertMsg(rc == ETIMEDOUT, ("Failed read lock read-write sem %p, rc=%d.\n", hRWSem, rc));
             return RTErrConvertFromErrno(rc);
         }
@@ -512,49 +512,49 @@
 
 #undef RTSemRWRequestWrite
-RTDECL(int) RTSemRWRequestWrite(RTSEMRW RWSem, unsigned cMillies)
+RTDECL(int) RTSemRWRequestWrite(RTSEMRW hRWSem, RTMSINTERVAL cMillies)
 {
 #ifndef RTSEMRW_STRICT
-    return rtSemRWRequestWrite(RWSem, cMillies, NULL);
+    return rtSemRWRequestWrite(hRWSem, cMillies, NULL);
 #else
     RTLOCKVALSRCPOS SrcPos = RTLOCKVALSRCPOS_INIT_NORMAL_API();
-    return rtSemRWRequestWrite(RWSem, cMillies, &SrcPos);
-#endif
-}
-
-
-RTDECL(int) RTSemRWRequestWriteDebug(RTSEMRW RWSem, unsigned cMillies, RTHCUINTPTR uId, RT_SRC_POS_DECL)
+    return rtSemRWRequestWrite(hRWSem, cMillies, &SrcPos);
+#endif
+}
+
+
+RTDECL(int) RTSemRWRequestWriteDebug(RTSEMRW hRWSem, RTMSINTERVAL cMillies, RTHCUINTPTR uId, RT_SRC_POS_DECL)
 {
     RTLOCKVALSRCPOS SrcPos = RTLOCKVALSRCPOS_INIT_DEBUG_API();
-    return rtSemRWRequestWrite(RWSem, cMillies, &SrcPos);
+    return rtSemRWRequestWrite(hRWSem, cMillies, &SrcPos);
 }
 
 
 #undef RTSemRWRequestWriteNoResume
-RTDECL(int) RTSemRWRequestWriteNoResume(RTSEMRW RWSem, unsigned cMillies)
+RTDECL(int) RTSemRWRequestWriteNoResume(RTSEMRW hRWSem, RTMSINTERVAL cMillies)
 {
     /* EINTR isn't returned by the wait functions we're using. */
 #ifndef RTSEMRW_STRICT
-    return rtSemRWRequestWrite(RWSem, cMillies, NULL);
+    return rtSemRWRequestWrite(hRWSem, cMillies, NULL);
 #else
     RTLOCKVALSRCPOS SrcPos = RTLOCKVALSRCPOS_INIT_NORMAL_API();
-    return rtSemRWRequestWrite(RWSem, cMillies, &SrcPos);
-#endif
-}
-
-
-RTDECL(int) RTSemRWRequestWriteNoResumeDebug(RTSEMRW RWSem, unsigned cMillies, RTHCUINTPTR uId, RT_SRC_POS_DECL)
+    return rtSemRWRequestWrite(hRWSem, cMillies, &SrcPos);
+#endif
+}
+
+
+RTDECL(int) RTSemRWRequestWriteNoResumeDebug(RTSEMRW hRWSem, RTMSINTERVAL cMillies, RTHCUINTPTR uId, RT_SRC_POS_DECL)
 {
     /* EINTR isn't returned by the wait functions we're using. */
     RTLOCKVALSRCPOS SrcPos = RTLOCKVALSRCPOS_INIT_DEBUG_API();
-    return rtSemRWRequestWrite(RWSem, cMillies, &SrcPos);
-}
-
-
-RTDECL(int) RTSemRWReleaseWrite(RTSEMRW RWSem)
-{
-    /*
-     * Validate input.
-     */
-    struct RTSEMRWINTERNAL *pThis = RWSem;
+    return rtSemRWRequestWrite(hRWSem, cMillies, &SrcPos);
+}
+
+
+RTDECL(int) RTSemRWReleaseWrite(RTSEMRW hRWSem)
+{
+    /*
+     * Validate input.
+     */
+    struct RTSEMRWINTERNAL *pThis = hRWSem;
     AssertPtrReturn(pThis, VERR_INVALID_HANDLE);
     AssertMsgReturn(pThis->u32Magic == RTSEMRW_MAGIC,
@@ -596,5 +596,5 @@
     if (rc)
     {
-        AssertMsgFailed(("Failed write unlock read-write sem %p, rc=%d.\n", RWSem, rc));
+        AssertMsgFailed(("Failed write unlock read-write sem %p, rc=%d.\n", hRWSem, rc));
         return RTErrConvertFromErrno(rc);
     }
@@ -604,10 +604,10 @@
 
 
-RTDECL(bool) RTSemRWIsWriteOwner(RTSEMRW RWSem)
-{
-    /*
-     * Validate input.
-     */
-    struct RTSEMRWINTERNAL *pThis = RWSem;
+RTDECL(bool) RTSemRWIsWriteOwner(RTSEMRW hRWSem)
+{
+    /*
+     * Validate input.
+     */
+    struct RTSEMRWINTERNAL *pThis = hRWSem;
     AssertPtrReturn(pThis, false);
     AssertMsgReturn(pThis->u32Magic == RTSEMRW_MAGIC,
@@ -625,10 +625,10 @@
 
 
-RTDECL(uint32_t) RTSemRWGetWriteRecursion(RTSEMRW RWSem)
-{
-    /*
-     * Validate input.
-     */
-    struct RTSEMRWINTERNAL *pThis = RWSem;
+RTDECL(uint32_t) RTSemRWGetWriteRecursion(RTSEMRW hRWSem)
+{
+    /*
+     * Validate input.
+     */
+    struct RTSEMRWINTERNAL *pThis = hRWSem;
     AssertPtrReturn(pThis, 0);
     AssertMsgReturn(pThis->u32Magic == RTSEMRW_MAGIC,
@@ -643,10 +643,10 @@
 
 
-RTDECL(uint32_t) RTSemRWGetWriterReadRecursion(RTSEMRW RWSem)
-{
-    /*
-     * Validate input.
-     */
-    struct RTSEMRWINTERNAL *pThis = RWSem;
+RTDECL(uint32_t) RTSemRWGetWriterReadRecursion(RTSEMRW hRWSem)
+{
+    /*
+     * Validate input.
+     */
+    struct RTSEMRWINTERNAL *pThis = hRWSem;
     AssertPtrReturn(pThis, 0);
     AssertMsgReturn(pThis->u32Magic == RTSEMRW_MAGIC,
@@ -661,10 +661,10 @@
 
 
-RTDECL(uint32_t) RTSemRWGetReadCount(RTSEMRW RWSem)
-{
-    /*
-     * Validate input.
-     */
-    struct RTSEMRWINTERNAL *pThis = RWSem;
+RTDECL(uint32_t) RTSemRWGetReadCount(RTSEMRW hRWSem)
+{
+    /*
+     * Validate input.
+     */
+    struct RTSEMRWINTERNAL *pThis = hRWSem;
     AssertPtrReturn(pThis, 0);
     AssertMsgReturn(pThis->u32Magic == RTSEMRW_MAGIC,