Index: trunk/include/iprt/file.h
===================================================================
--- trunk/include/iprt/file.h	(revision 25723)
+++ trunk/include/iprt/file.h	(revision 25724)
@@ -1195,6 +1195,6 @@
  * @param   cMinReqs        The minimum number of requests which have to
  *                          complete before this function returns.
- * @param   cMillisTimeout  The number of milliseconds to wait before returning
- *                          VERR_TIMEOUT. Use RT_INDEFINITE_WAIT to wait
+ * @param   cMillies        The number of milliseconds to wait before returning
+ *                          VERR_TIMEOUT.  Use RT_INDEFINITE_WAIT to wait
  *                          forever.
  * @param   pahReqs         Pointer to an array where the handles of the
@@ -1212,5 +1212,5 @@
  *          RT_ELEMENTS and similar macros.
  */
-RTDECL(int) RTFileAioCtxWait(RTFILEAIOCTX hAioCtx, size_t cMinReqs, unsigned cMillisTimeout,
+RTDECL(int) RTFileAioCtxWait(RTFILEAIOCTX hAioCtx, size_t cMinReqs, RTMSINTERVAL cMillies,
                              PRTFILEAIOREQ pahReqs, size_t cReqs, uint32_t *pcReqs);
 
Index: trunk/include/iprt/req.h
===================================================================
--- trunk/include/iprt/req.h	(revision 25723)
+++ trunk/include/iprt/req.h	(revision 25724)
@@ -186,5 +186,5 @@
  *                          Use RT_INDEFINITE_WAIT to only wait till one is added.
  */
-RTDECL(int) RTReqProcess(PRTREQQUEUE pQueue, unsigned cMillies);
+RTDECL(int) RTReqProcess(PRTREQQUEUE pQueue, RTMSINTERVAL cMillies);
 
 
@@ -213,5 +213,5 @@
  * @remarks See remarks on RTReqCallV.
  */
-RTDECL(int) RTReqCall(PRTREQQUEUE pQueue, PRTREQ *ppReq, unsigned cMillies, PFNRT pfnFunction, unsigned cArgs, ...);
+RTDECL(int) RTReqCall(PRTREQQUEUE pQueue, PRTREQ *ppReq, RTMSINTERVAL cMillies, PFNRT pfnFunction, unsigned cArgs, ...);
 
 
@@ -240,5 +240,5 @@
  * @remarks See remarks on RTReqCallV.
  */
-RTDECL(int) RTReqCallVoid(PRTREQQUEUE pQueue, PRTREQ *ppReq, unsigned cMillies, PFNRT pfnFunction, unsigned cArgs, ...);
+RTDECL(int) RTReqCallVoid(PRTREQQUEUE pQueue, PRTREQ *ppReq, RTMSINTERVAL cMillies, PFNRT pfnFunction, unsigned cArgs, ...);
 
 
@@ -269,5 +269,5 @@
  * @remarks See remarks on RTReqCallV.
  */
-RTDECL(int) RTReqCallEx(PRTREQQUEUE pQueue, PRTREQ *ppReq, unsigned cMillies, unsigned fFlags, PFNRT pfnFunction, unsigned cArgs, ...);
+RTDECL(int) RTReqCallEx(PRTREQQUEUE pQueue, PRTREQ *ppReq, RTMSINTERVAL cMillies, unsigned fFlags, PFNRT pfnFunction, unsigned cArgs, ...);
 
 
@@ -305,5 +305,5 @@
  *                Use (void *)NULL or (uintptr_t)0 instead of NULL.
  */
-RTDECL(int) RTReqCallV(PRTREQQUEUE pQueue, PRTREQ *ppReq, unsigned cMillies, unsigned fFlags, PFNRT pfnFunction, unsigned cArgs, va_list Args);
+RTDECL(int) RTReqCallV(PRTREQQUEUE pQueue, PRTREQ *ppReq, RTMSINTERVAL cMillies, unsigned fFlags, PFNRT pfnFunction, unsigned cArgs, va_list Args);
 
 
@@ -352,5 +352,5 @@
  *                          wait till it's completed.
  */
-RTDECL(int) RTReqQueue(PRTREQ pReq, unsigned cMillies);
+RTDECL(int) RTReqQueue(PRTREQ pReq, RTMSINTERVAL cMillies);
 
 
@@ -366,5 +366,5 @@
  *                          Use RT_INDEFINITE_WAIT to only wait till it's completed.
  */
-RTDECL(int) RTReqWait(PRTREQ pReq, unsigned cMillies);
+RTDECL(int) RTReqWait(PRTREQ pReq, RTMSINTERVAL cMillies);
 
 /**
Index: trunk/include/iprt/semaphore.h
===================================================================
--- trunk/include/iprt/semaphore.h	(revision 25723)
+++ trunk/include/iprt/semaphore.h	(revision 25724)
@@ -123,5 +123,5 @@
  * @param   cMillies            Number of milliseconds to wait.
  */
-RTDECL(int)  RTSemEventWait(RTSEMEVENT hEventSem, unsigned cMillies);
+RTDECL(int)  RTSemEventWait(RTSEMEVENT hEventSem, RTMSINTERVAL cMillies);
 
 /**
@@ -134,5 +134,5 @@
  * @param   cMillies            Number of milliseconds to wait.
  */
-RTDECL(int)  RTSemEventWaitNoResume(RTSEMEVENT hEventSem, unsigned cMillies);
+RTDECL(int)  RTSemEventWaitNoResume(RTSEMEVENT hEventSem, RTMSINTERVAL cMillies);
 
 /**
@@ -251,5 +251,5 @@
  * @param   cMillies            Number of milliseconds to wait.
  */
-RTDECL(int)  RTSemEventMultiWait(RTSEMEVENTMULTI hEventMultiSem, unsigned cMillies);
+RTDECL(int)  RTSemEventMultiWait(RTSEMEVENTMULTI hEventMultiSem, RTMSINTERVAL cMillies);
 
 
@@ -263,5 +263,5 @@
  * @param   cMillies            Number of milliseconds to wait.
  */
-RTDECL(int)  RTSemEventMultiWaitNoResume(RTSEMEVENTMULTI hEventMultiSem, unsigned cMillies);
+RTDECL(int)  RTSemEventMultiWaitNoResume(RTSEMEVENTMULTI hEventMultiSem, RTMSINTERVAL cMillies);
 
 /**
@@ -389,5 +389,5 @@
  * @param   cMillies            The number of milliseconds to wait.
  */
-RTDECL(int)  RTSemMutexRequest(RTSEMMUTEX hMutexSem, unsigned cMillies);
+RTDECL(int)  RTSemMutexRequest(RTSEMMUTEX hMutexSem, RTMSINTERVAL cMillies);
 
 /**
@@ -404,5 +404,5 @@
  * @param   cMillies            The number of milliseconds to wait.
  */
-RTDECL(int)  RTSemMutexRequestNoResume(RTSEMMUTEX hMutexSem, unsigned cMillies);
+RTDECL(int)  RTSemMutexRequestNoResume(RTSEMMUTEX hMutexSem, RTMSINTERVAL cMillies);
 
 /**
@@ -421,5 +421,5 @@
  *                              from.  Optional.
  */
-RTDECL(int)  RTSemMutexRequestDebug(RTSEMMUTEX hMutexSem, unsigned cMillies, RTHCUINTPTR uId, RT_SRC_POS_DECL);
+RTDECL(int)  RTSemMutexRequestDebug(RTSEMMUTEX hMutexSem, RTMSINTERVAL cMillies, RTHCUINTPTR uId, RT_SRC_POS_DECL);
 
 /**
@@ -437,5 +437,5 @@
  *                              from.  Optional.
  */
-RTDECL(int)  RTSemMutexRequestNoResumeDebug(RTSEMMUTEX hMutexSem, unsigned cMillies, RTHCUINTPTR uId, RT_SRC_POS_DECL);
+RTDECL(int)  RTSemMutexRequestNoResumeDebug(RTSEMMUTEX hMutexSem, RTMSINTERVAL cMillies, RTHCUINTPTR uId, RT_SRC_POS_DECL);
 
 /**
@@ -976,5 +976,5 @@
  * @param   cMillies    Number of milliseconds to wait.
  */
-RTDECL(int) RTSemPingWait(PRTPINGPONG pPP, unsigned cMillies);
+RTDECL(int) RTSemPingWait(PRTPINGPONG pPP, RTMSINTERVAL cMillies);
 
 /**
@@ -986,5 +986,5 @@
  * @param   cMillies    Number of milliseconds to wait.
  */
-RTDECL(int) RTSemPongWait(PRTPINGPONG pPP, unsigned cMillies);
+RTDECL(int) RTSemPongWait(PRTPINGPONG pPP, RTMSINTERVAL cMillies);
 
 
Index: trunk/include/iprt/tcp.h
===================================================================
--- trunk/include/iprt/tcp.h	(revision 25723)
+++ trunk/include/iprt/tcp.h	(revision 25724)
@@ -198,5 +198,5 @@
  *                      Use RT_INDEFINITE_WAIT to wait for ever.
  */
-RTR3DECL(int)  RTTcpSelectOne(RTSOCKET Sock, unsigned cMillies);
+RTR3DECL(int)  RTTcpSelectOne(RTSOCKET Sock, RTMSINTERVAL cMillies);
 
 
Index: trunk/include/iprt/thread.h
===================================================================
--- trunk/include/iprt/thread.h	(revision 25723)
+++ trunk/include/iprt/thread.h	(revision 25724)
@@ -200,5 +200,5 @@
  * @remark  See RTThreadNanoSleep() for sleeping for smaller periods of time.
  */
-RTDECL(int) RTThreadSleep(unsigned cMillies);
+RTDECL(int) RTThreadSleep(RTMSINTERVAL cMillies);
 
 /**
@@ -334,5 +334,5 @@
  * @param       prc             Where to store the return code of the thread. Optional.
  */
-RTDECL(int) RTThreadWait(RTTHREAD Thread, unsigned cMillies, int *prc);
+RTDECL(int) RTThreadWait(RTTHREAD Thread, RTMSINTERVAL cMillies, int *prc);
 
 /**
@@ -345,5 +345,5 @@
  * @param       prc             Where to store the return code of the thread. Optional.
  */
-RTDECL(int) RTThreadWaitNoResume(RTTHREAD Thread, unsigned cMillies, int *prc);
+RTDECL(int) RTThreadWaitNoResume(RTTHREAD Thread, RTMSINTERVAL cMillies, int *prc);
 
 /**
@@ -406,5 +406,5 @@
  *                              an indefinite wait.
  */
-RTDECL(int) RTThreadUserWait(RTTHREAD Thread, unsigned cMillies);
+RTDECL(int) RTThreadUserWait(RTTHREAD Thread, RTMSINTERVAL cMillies);
 
 /**
@@ -416,5 +416,5 @@
  *                              an indefinite wait.
  */
-RTDECL(int) RTThreadUserWaitNoResume(RTTHREAD Thread, unsigned cMillies);
+RTDECL(int) RTThreadUserWaitNoResume(RTTHREAD Thread, RTMSINTERVAL cMillies);
 
 /**