Index: trunk/include/VBox/VBoxHDD.h
===================================================================
--- trunk/include/VBox/VBoxHDD.h	(revision 25672)
+++ trunk/include/VBox/VBoxHDD.h	(revision 25728)
@@ -977,5 +977,5 @@
      *                      Use RT_INDEFINITE_WAIT to wait for ever.
      */
-    DECLR3CALLBACKMEMBER(int, pfnSelectOne, (RTSOCKET Sock, unsigned cMillies));
+    DECLR3CALLBACKMEMBER(int, pfnSelectOne, (RTSOCKET Sock, RTMSINTERVAL cMillies));
 
     /**
Index: trunk/include/VBox/dbgf.h
===================================================================
--- trunk/include/VBox/dbgf.h	(revision 25672)
+++ trunk/include/VBox/dbgf.h	(revision 25728)
@@ -294,5 +294,5 @@
 VMMR3DECL(int)  DBGFR3Attach(PVM pVM);
 VMMR3DECL(int)  DBGFR3Detach(PVM pVM);
-VMMR3DECL(int)  DBGFR3EventWait(PVM pVM, unsigned cMillies, PCDBGFEVENT *ppEvent);
+VMMR3DECL(int)  DBGFR3EventWait(PVM pVM, RTMSINTERVAL cMillies, PCDBGFEVENT *ppEvent);
 VMMR3DECL(int)  DBGFR3Halt(PVM pVM);
 VMMR3DECL(bool) DBGFR3IsHalted(PVM pVM);
Index: trunk/include/VBox/pdmifs.h
===================================================================
--- trunk/include/VBox/pdmifs.h	(revision 25672)
+++ trunk/include/VBox/pdmifs.h	(revision 25728)
@@ -2104,5 +2104,5 @@
      * @param   cMillies        Number of milliseconds to wait. 0 means return immediately.
      */
-    DECLR3CALLBACKMEMBER(int, pfnWaitReceiveAvail,(PPDMINETWORKPORT pInterface, unsigned cMillies));
+    DECLR3CALLBACKMEMBER(int, pfnWaitReceiveAvail,(PPDMINETWORKPORT pInterface, RTMSINTERVAL cMillies));
 
     /**
Index: trunk/include/VBox/pdmthread.h
===================================================================
--- trunk/include/VBox/pdmthread.h	(revision 25672)
+++ trunk/include/VBox/pdmthread.h	(revision 25728)
@@ -291,5 +291,5 @@
 VMMR3DECL(int) PDMR3ThreadIAmSuspending(PPDMTHREAD pThread);
 VMMR3DECL(int) PDMR3ThreadIAmRunning(PPDMTHREAD pThread);
-VMMR3DECL(int) PDMR3ThreadSleep(PPDMTHREAD pThread, unsigned cMillies);
+VMMR3DECL(int) PDMR3ThreadSleep(PPDMTHREAD pThread, RTMSINTERVAL cMillies);
 VMMR3DECL(int) PDMR3ThreadSuspend(PPDMTHREAD pThread);
 VMMR3DECL(int) PDMR3ThreadResume(PPDMTHREAD pThread);
Index: trunk/include/VBox/pdmusb.h
===================================================================
--- trunk/include/VBox/pdmusb.h	(revision 25672)
+++ trunk/include/VBox/pdmusb.h	(revision 25728)
@@ -356,5 +356,5 @@
      * @remarks Mandatory.
      */
-    DECLR3CALLBACKMEMBER(PVUSBURB, pfnUrbReap,(PPDMUSBINS pUsbIns, unsigned cMillies));
+    DECLR3CALLBACKMEMBER(PVUSBURB, pfnUrbReap,(PPDMUSBINS pUsbIns, RTMSINTERVAL cMillies));
 
 
Index: trunk/include/VBox/vmapi.h
===================================================================
--- trunk/include/VBox/vmapi.h	(revision 25672)
+++ trunk/include/VBox/vmapi.h	(revision 25728)
@@ -371,7 +371,7 @@
 VMMR3DECL(int)      VMR3SetRuntimeErrorWorker(PVM pVM);
 VMMR3DECL(uint32_t) VMR3GetRuntimeErrorCount(PVM pVM);
-VMMR3DECL(int)      VMR3ReqCall(PVM pVM, VMCPUID idDstCpu, PVMREQ *ppReq, unsigned cMillies, uint32_t fFlags, PFNRT pfnFunction, unsigned cArgs, ...);
-VMMR3DECL(int)      VMR3ReqCallU(PUVM pUVM, VMCPUID idDstCpu, PVMREQ *ppReq, unsigned cMillies, unsigned fFlags, PFNRT pfnFunction, unsigned cArgs, ...);
-VMMR3DECL(int)      VMR3ReqCallVU(PUVM pUVM, VMCPUID idDstCpu, PVMREQ *ppReq, unsigned cMillies, unsigned fFlags, PFNRT pfnFunction, unsigned cArgs, va_list Args);
+VMMR3DECL(int)      VMR3ReqCall(PVM pVM, VMCPUID idDstCpu, PVMREQ *ppReq, RTMSINTERVAL cMillies, uint32_t fFlags, PFNRT pfnFunction, unsigned cArgs, ...);
+VMMR3DECL(int)      VMR3ReqCallU(PUVM pUVM, VMCPUID idDstCpu, PVMREQ *ppReq, RTMSINTERVAL cMillies, uint32_t fFlags, PFNRT pfnFunction, unsigned cArgs, ...);
+VMMR3DECL(int)      VMR3ReqCallVU(PUVM pUVM, VMCPUID idDstCpu, PVMREQ *ppReq, RTMSINTERVAL cMillies, uint32_t fFlags, PFNRT pfnFunction, unsigned cArgs, va_list Args);
 VMMR3DECL(int)      VMR3ReqCallWait(PVM pVM, VMCPUID idDstCpu, PFNRT pfnFunction, unsigned cArgs, ...);
 VMMR3DECL(int)      VMR3ReqCallWaitU(PUVM pUVM, VMCPUID idDstCpu, PFNRT pfnFunction, unsigned cArgs, ...);
@@ -385,6 +385,6 @@
 VMMR3DECL(int)      VMR3ReqAllocU(PUVM pUVM, PVMREQ *ppReq, VMREQTYPE enmType, VMCPUID idDstCpu);
 VMMR3DECL(int)      VMR3ReqFree(PVMREQ pReq);
-VMMR3DECL(int)      VMR3ReqQueue(PVMREQ pReq, unsigned cMillies);
-VMMR3DECL(int)      VMR3ReqWait(PVMREQ pReq, unsigned cMillies);
+VMMR3DECL(int)      VMR3ReqQueue(PVMREQ pReq, RTMSINTERVAL cMillies);
+VMMR3DECL(int)      VMR3ReqWait(PVMREQ pReq, RTMSINTERVAL cMillies);
 VMMR3DECL(int)      VMR3ReqProcessU(PUVM pUVM, VMCPUID idDstCpu);
 VMMR3DECL(void)     VMR3NotifyGlobalFFU(PUVM pUVM, uint32_t fFlags);
Index: trunk/include/VBox/vusb.h
===================================================================
--- trunk/include/VBox/vusb.h	(revision 25672)
+++ trunk/include/VBox/vusb.h	(revision 25728)
@@ -479,5 +479,5 @@
      * @param   cMillies    Number of milliseconds to poll for completion.
      */
-    DECLR3CALLBACKMEMBER(void, pfnReapAsyncUrbs,(PVUSBIROOTHUBCONNECTOR pInterface, unsigned cMillies));
+    DECLR3CALLBACKMEMBER(void, pfnReapAsyncUrbs,(PVUSBIROOTHUBCONNECTOR pInterface, RTMSINTERVAL cMillies));
 
     /**
@@ -526,5 +526,5 @@
 
 /** @copydoc VUSBIROOTHUBCONNECTOR::pfnReapAsyncUrbs */
-DECLINLINE(void) VUSBIRhReapAsyncUrbs(PVUSBIROOTHUBCONNECTOR pInterface, unsigned cMillies)
+DECLINLINE(void) VUSBIRhReapAsyncUrbs(PVUSBIROOTHUBCONNECTOR pInterface, RTMSINTERVAL cMillies)
 {
     pInterface->pfnReapAsyncUrbs(pInterface, cMillies);